# How to build always-succeeds.plutus in Aiken

## Step by Step
To get started with Aiken, we will follow the [Hello World tutorial in the official Aiken documentation](https://aiken-lang.org/example--hello-world)

### Step 1: Install Rust
- To install [Rust](https://www.rust-lang.org/) and the [Cargo package manager](https://doc.rust-lang.org/cargo/), [follow the official documentation](https://doc.rust-lang.org/book/ch01-01-installation.html)
- If you want to learn more about Rust, the [Rust Book](https://doc.rust-lang.org/book/title-page.html) is very good: 

You will know you are successful if you can run `rustc --version` and `cargo --version`:
```bash
$ rustc --version
rustc 1.68.0 (2c8cc3432 2023-03-06)
$ cargo --version
cargo 1.68.0 (115f34552 2023-02-26)
```

### Step 2: Install Aiken
- Review the [Aiken documentation](https://aiken-lang.org/installation-instructions)
- Installs globally
Aiken will be installed globally, which means that you can use it from anywhere on your computer. 

You will know you are successful if you can run `aiken -V`:
```bash
$ aiken -V
aiken 0.0.29
```

### Step 3: Follow Aiken Hello World tutorial
[Give it a try!](https://aiken-lang.org/example--hello-world)

### Step 4: Simplify the Validator to make it Always Succeeds!
Instead of writing `hello_world.ak`, we can write an even simpler validator called `always_succeeds.ak`:
```rust
validator {
  fn always_succeed(_datum: Data, _redeemer: Data, _context: Data) -> Bool {
    True
  }
}
```

After you write `always_succeeds.ak`, run `aiken build` and look at the resulting `plutus.json` file.

### Step 5 (Optional): Try to clear the warnings
If you follow along with the video above or the steps listed here, you should end up with some warnings after running `aiken build`. To learn more about how Aiken works, read each of these warnings. Try to eliminate all of them, and run `aiken build` again.

## Notes:
### In Aiken, the output is a `.json` file
- This represents cutting-edge work in Cardano development
- A standard "contract blueprint" will allow developers to build interoperable tooling - just like they did for Cardano NFTs!
- To learn more, [read CIP 57](https://github.com/cardano-foundation/CIPs/tree/KtorZ/CIP-0054/plutus-contract-blueprint/CIP-0057). We will investigate this [Cardano Improvement Proposal and others](https://cips.cardano.org/) throughout PPBL 2023.


import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
